#!/bin/bash

set -o errexit
trap "rm -rf 3GPP_enhanced_aacPlus_src_200907 *.c *.h readme.txt *.new *.def *.all" 0

cd "$1"

mv config.h config.h.save
rm -rf 3GPP_enhanced_aacPlus_src_200907 *.c *.h readme.txt
mv config.h.save config.h
/usr/bin/unzip 26410-720-ANSI-C_source_code.zip

cp 3GPP_enhanced_aacPlus_src_*/FloatFR_aacPlusenc/FloatFR*/*.h ./
cp 3GPP_enhanced_aacPlus_src_*/FloatFR_aacPlusenc/FloatFR*/src/*.h ./
cp 3GPP_enhanced_aacPlus_src_*/FloatFR_aacPlusenc/FloatFR*/src/*.c ./
cp 3GPP_enhanced_aacPlus_src_*/README_enc.txt readme.txt
cp 3GPP_enhanced_aacPlus_src_*/FloatFR_aacPlusenc/src/main.c aacplusenc.c

for FILE in readme.txt *.c  *.h ; do
    tr -d '\r\000' <$FILE >${FILE#*/}.new
    mv ${FILE#*/}.new ${FILE#*/}
done

rm -r 3GPP_enhanced_aacPlus_src_200907
chmod -x-x-x *.c *.h

/usr/bin/patch <aacplusenc-fftw3f.patch
/usr/bin/patch <aacplusenc-ps-long-to-int.patch
/usr/bin/patch <aacplusenc-add-bitrates.patch
/usr/bin/patch <aacplusenc-adts.patch
/usr/bin/patch <aacplusenc-cpp-compat.patch
/usr/bin/patch <aacplusenc-enchaacplusenc.patch
/usr/bin/patch <aacplusenc-faac-compatible.patch

#for FILE in dec_if.[ch] enc_if.[ch] ; do
#    echo "modifying file $FILE"
#    if test $FILE = ${FILE%.h} ; then
#	ENDSTRING="^}"
#    else
#	ENDSTRING=");"
#    fi
#    sed -n "/^[^# ][^ ]* ._IF_..code/,/$ENDSTRING/p" <$FILE >$FILE.def
#    sed 's/^\([^# ][^ ]*\) \(._IF_..code\)/\1 GP3\2/
#	 s:ifndef IF2:if 1 /* & */:
#	 s:ifdef IF2:if 0 /* & */:
#	' <$FILE.def >$FILE.all
#    sed 's/^\([^# ][^ ]*\) \(._IF_..code\)/\1 IF2\2/
#	 s:ifndef IF2:if 0 /* & */:
#	 s:ifdef IF2:if 1 /* & */:
#	' <$FILE.def >>$FILE.all
#    sed "/^[^# ][^ ]* ._IF_..code/,/$ENDSTRING/c\\
#/* Double the code with different defines and names */
#" <$FILE |
#    sed "/Double the code with different defines and names/r $FILE.all" >$FILE.new
#    mv $FILE.new $FILE
#    rm $FILE.def $FILE.all
#done

trap 0
